package test;

import main.ConfigureDriver;
import main.DomainGrabber;
import org.openqa.selenium.NoSuchElementException;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.By;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.CsvFileSource;
import static org.junit.jupiter.api.Assertions.assertTrue;
import static org.junit.jupiter.api.Assertions.assertFalse;

public class TestPoster {
    private static final String domain = DomainGrabber.getDomain();
    private static final String LOGIN_PAGE = "https://"+domain+"/wp-login.php";
    private static final String USERNAME_BOX_ID = "user_login";
    private static final String PASSWORD_BOX_ID = "user_pass";
    private static final String LOGIN_BUTTON_ID = "wp-submit";
    private static final String LOGGGEDIN_URL = "https://"+domain+"/wp-admin/";
    private static final String POST_BUTTON_ID = "wp-admin-bar-new-content";
    private static final String NEW_POST_URL = "https://"+domain+"/wp-admin/post-new.php";
    @ParameterizedTest
    @CsvFileSource(resources = "/csv/built/credentials_permissions.csv", numLinesToSkip = 0)

    public void testPostEditDelete(String role, String usernameText, String passwordText) {
        WebDriver driver = ConfigureDriver.configureDriver();
        driver.manage().window().maximize();
        driver.get(LOGIN_PAGE);

        WebElement username = driver.findElement(By.id(USERNAME_BOX_ID));
        WebElement password = driver.findElement(By.id(PASSWORD_BOX_ID));
        WebElement login = driver.findElement(By.id(LOGIN_BUTTON_ID));

        username.sendKeys(usernameText);
        System.out.println("Testing "+usernameText);
        password.sendKeys(passwordText);
        login.click();

        assertTrue(driver.getCurrentUrl().startsWith(LOGGGEDIN_URL));
        boolean canPost;
        if (role.equals("author")) {
            canPost = true;
        } else {
            canPost = false;
        }
        boolean postAccessible = true;
        try {
            WebElement post_button = driver.findElement(By.id(POST_BUTTON_ID));
            post_button.click();
        } catch(NoSuchElementException e) {
            postAccessible = false;
        }
        if (canPost) {
            assertTrue(driver.getCurrentUrl().startsWith(NEW_POST_URL));
        }
        else {
            assertTrue(postAccessible == false);
            assertFalse(driver.getCurrentUrl().startsWith(NEW_POST_URL));
        }

    }
        //driver.quit();
}